Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZIS6.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZIS6.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZIS6.m	(revision 623)
@@ -1,101 +1,88 @@
-%ZIS6	;SFISC/AC - DEVICE HANDLER -- RESOURCES ;1/24/08  16:09
-	;;8.0;KERNEL;**24,49,69,118,127,136,440**;JUL 10, 1995;Build 13
-	;Per VHA Directive 2004-038, this routine should not be modified
-	;Expect that IO is current device
-OXECUTE	;Open Execute
-	I $D(^%ZIS(2,%ZISIOST(0),2))=1 S %Y=^(2) D 2
-ANSBAK	;Answer Back
-	I $D(^%ZIS(2,%ZISIOST(0),102)) S %Y=^(102) D 2 E  S POP=1 D:'$D(IOP) SAY($C(7)_"[NOT ON LINE]") C:%ZISB IO K IO(1,IO) G QUIT
-	I $D(%ZISMTR) X ^%ZOSF("MAGTAPE") U IO W:$D(%MT("REW")) @%MT("REW") U IO(0) K %MT
-	G QUIT:'$D(IO("P"))
-	I $F(IO("P"),"B"),$D(^%ZIS(2,%ZISIOST(0),7)) S %Y=$P(^(7),"^",1) I %Y]"" W @%Y
-	S %Y=$F(IO("P"),"P") G QLTY:'%Y S %Y=+$E(IO("P"),%Y,99),%X=$S(%Y=16:12.1,%Y=10!(%Y=12):5,1:"") G QLTY:'%X
-	S %Y=$S($D(^%ZIS(2,%ZISIOST(0),%X)):$P(^(%X),"^",$S(%Y=12:2,1:1)),1:"")
-	I %Y]"" W @%Y
-QLTY	S %Y=$F(IO("P"),"Q") Q:'%Y  S %Y=+$E(IO("P"),%Y,99),%X=$S(%Y<0!(%Y>2):0,1:%Y+1)
-	I %X S %Y=$S($D(^%ZIS(2,%ZISIOST(0),12.2)):$P(^(12.2),"^",%X),1:"") I %Y]""  W @%Y
-QUIT	U:%IS'[0 IO(0)
-	Q
-2	Q:%Y=""  I %IS'[0,$D(^%ZIS(1,+%H,"TYPE")),^("TYPE")["TRM" D OH Q:POP
-	S %X=$T U IO D %Y^ZISX ;Q:'%X  U IO(0)
-	Q
-OH	Q:$S($G(IO(0))]"":$D(IO(1,IO(0))),1:0)
-	N X S X="OPNERR^%ZIS4",@^%ZOSF("TRAP")
-	O IO(0)::0 S IO(1,IO(0))="" Q  ;See that HOME DEVICE is open.
-	;
-SAY(%SAY)	;
-	Q:%IS[0  U IO(0) W %SAY U IO
-	Q
-RES1	;Allocate a resource slot, Release in %ZISC.
-	N A,L,X,%ZISD0
-	S %ZISD0=$O(^%ZISL(3.54,"B",IO,0))
-	I '%ZISD0 S %ZISD0=$$RADD(IO) ;New one
-	L +^%ZISL(3.54,%ZISD0,0):2 I '$T S POP=1 W:'$D(IOP) *7,"  [NOT Available]" G RESX
-RES2	S X=$P(^%ZISL(3.54,%ZISD0,0),"^",2)
-	I X<1 S POP=1 W:'$D(IOP) *7,"  [NOT Available]" G RESX
-	S X=$S(X>0:X-1,1:0),$P(^%ZISL(3.54,%ZISD0,0),"^",2)=X
-	;
-R1	;Grab a slot
-	S IO(1,IO)="RES",A=$G(^%ZISL(3.54,%ZISD0,1,0),"^3.542^^")
-	F L=1:1:%ZISRL I '$D(^%ZISL(3.54,%ZISD0,1,L,0)) Q
-	I '$T K IO(1,IO) G RES2 ;No free slots
-	S ^%ZISL(3.54,%ZISD0,1,L,0)=L_"^"_%ZISV_"^"_$J_"^"_$G(ZTSK)_"^"_$H,^%ZISL(3.54,"AJ",$J,%ZISD0,L)="",^%ZISL(3.54,%ZISD0,1,"B",L,L)=""
-	S $P(A,"^",3,4)=L_U_($P(A,U,4)+1),^%ZISL(3.54,%ZISD0,1,0)=A
-RESX	L -^%ZISL(3.54,%ZISD0,0) Q
-	;
-RADD(X)	;Add Resource
-	N %1,%2
-	S %1=$G(^%ZISL(3.54,0),"RESOURCE^3.54^^"),%2=$P(%1,U,3)
-	F %2=%2:1 Q:'$D(^%ZISL(3.54,%2,0))
-	S $P(^%ZISL(3.54,0),U,3,4)=%2_U_($P(%1,U,4)+1),^%ZISL(3.54,%2,0)=X_"^"_$G(%ZISRL,1),^%ZISL(3.54,"B",X,%2)=""
-	Q %2
-	;
-RESOK	;DEVOK check for RES devices, for all OS's.
-	N %ZISD0,%ZISD1
-	S Y=0,%ZISD0=$O(^%ZISL(3.54,"B",X,0))
-	I '%ZISD0 S Y=-1,%ZISD0=$O(^%ZIS(1,"C",X,0)) Q:'%ZISD0  Q:'$D(^%ZIS(1,+%ZISD0,0))  Q:$P(^(0),"^")'=X  Q:'$D(^("TYPE"))  Q:^("TYPE")'="RES"  S Y=0 Q
-	S X1=$G(^%ZISL(3.54,+%ZISD0,0))
-	I $P(X1,"^",2)&(X=$P(X1,"^")) S Y=0 Q
-	S Y=999 F %ZISD1=0:0 S %ZISD1=$O(^%ZISL(3.54,%ZISD0,1,%ZISD1)) Q:%ZISD1'>0  I $D(^(%ZISD1,0)) S Y=$P(^(0),"^",3) Q
-	Q
-	;
-Q	G Q^%ZIS3
-HG	;
-	Q
-SPL	;Spool type
-	N %E,%Z D MARGN^%ZIS3 W:'$D(IOP) ! D SPOOL^%ZIS4:%IS'["T"
-	G Q
-MT	D MARGN^%ZIS3,ASKPAR,AMTREW:'POP&'$D(IOP)&%ZISB W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T")) ;Magtape type
-	G Q
-SDP	;Sequential disk processor type
-	D MARGN^%ZIS3,ASKPAR W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T"))
-	G Q
-HFS	;Host File Server type
-	D MARGN^%ZIS3,HFS^%ZIS4 W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T"))
-	G Q
-RES	;Resources
-	G Q:%IS["T" N X,X1 I %IS'["R"!'$D(IOP) S POP=1 W:'$D(IOP) *7,"  [NOT AVAILABLE]" Q
-	G Q:$D(IO(1,IO)) I %IS["T" S X=IO,X1="RES" D DEVOK^%ZIS3 S:Y POP=1 G Q:POP
-	D:%ZISB RES1 G Q
-CHAN	;Network Channel type devices -- DecNet or TCP/IP devices.
-	I IO="SYS$NET",$I="SYS$INPUT:;" S IO(0)=IO U IO ;DECNET Server Device
-	D MARGN^%ZIS3:'POP,ASKPAR:'POP W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T"))
-	G Q
-IMPC	;Imaging Work Station
-BAR	;Bar Code
-OTH	;Other Device type
-	D MARGN^%ZIS3:'POP,ASKPAR:'POP W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T"))
-	G Q
-	;
-ASKPAR	;Ask Parameters
-	G SETPAR^%ZIS3:$D(IOP),SETPAR^%ZIS3:'$P(^%ZIS(1,%E,0),"^",4) W "  ADDRESS/PARAMETERS: " W:%ZISOPAR]"" %ZISOPAR_"// " D SBR^%ZIS1 D MSG1:%X="?" G ASKPAR:%X="?" S:%X]"" %ZISOPAR=%X I $D(DTOUT)!$D(DUOUT) S POP=1
-	I POP,%ZISB&(%ZTYPE["TRM") C IO K IO(1,IO) Q
-	Q:POP  G SETPAR^%ZIS3
-	;
-AMTREW	;Mag Tape Rewind
-	I %ZISB,%ZTYPE="MT",'$D(IOP) W "  REWIND" S %=2,U="^",%ZISDTIM=60 D YN^%ZIS1 K %ZISDTIM G AMTREW:%=0 I %=-1 S POP=1 Q
-	S:%=1 %ZISMTR=1
-	Q
-MSG1	W !?5,"Enter the desired parameters needed to open the selected device.",!?25
-	Q
-	;
+%ZIS6 ;SFISC/AC - DEVICE HANDLER -- RESOURCES ;02/04/2000  08:14
+ ;;8.0;KERNEL;**24,49,69,118,127,136**;JUL 10, 1995
+ ;Expect that IO is current device
+OXECUTE I $D(^%ZIS(2,%ZISIOST(0),2))=1 S %Y=^(2) D 2
+ANSBAK I $D(^%ZIS(2,%ZISIOST(0),102)) S %Y=^(102) D 2 E  S POP=1 D:'$D(IOP) SAY($C(7)_"[NOT ON LINE]") C:%ZISB IO K IO(1,IO) G QUIT
+ I $D(%ZISMTR) X ^%ZOSF("MAGTAPE") U IO W:$D(%MT("REW")) @%MT("REW") U IO(0) K %MT
+ G QUIT:'$D(IO("P"))
+ I $F(IO("P"),"B"),$D(^%ZIS(2,%ZISIOST(0),7)) S %Y=$P(^(7),"^",1) I %Y]"" W @%Y
+ S %Y=$F(IO("P"),"P") G QLTY:'%Y S %Y=+$E(IO("P"),%Y,99),%X=$S(%Y=16:12.1,%Y=10!(%Y=12):5,1:"") G QLTY:'%X
+ S %Y=$S($D(^%ZIS(2,%ZISIOST(0),%X)):$P(^(%X),"^",$S(%Y=12:2,1:1)),1:"")
+ I %Y]"" W @%Y
+QLTY S %Y=$F(IO("P"),"Q") Q:'%Y  S %Y=+$E(IO("P"),%Y,99),%X=$S(%Y<0!(%Y>2):0,1:%Y+1)
+ I %X S %Y=$S($D(^%ZIS(2,%ZISIOST(0),12.2)):$P(^(12.2),"^",%X),1:"") I %Y]""  W @%Y
+QUIT U:%IS'[0 IO(0)
+ Q
+2 Q:%Y=""  I %IS'[0,$D(^%ZIS(1,+%H,"TYPE")),^("TYPE")["TRM" D OH Q:POP
+ S %X=$T U IO D %Y^ZISX ;Q:'%X  U IO(0)
+ Q
+OH Q:$S($G(IO(0))]"":$D(IO(1,IO(0))),1:0)
+ N X S X="OPNERR^%ZIS4",@^%ZOSF("TRAP")
+ O IO(0)::0 S IO(1,IO(0))="" Q  ;See that HOME DEVICE is open.
+ ;
+SAY(%SAY) ;
+ Q:%IS[0  U IO(0) W %SAY U IO
+ Q
+RES1 ;Allocate a resource slot, Release in %ZISC.
+ N A,L,X,%ZISD0
+ S %ZISD0=$O(^%ZISL(3.54,"B",IO,0))
+ I '%ZISD0 S %ZISD0=$$RADD(IO) ;New one
+ L +^%ZISL(3.54,%ZISD0,0):2 I '$T S POP=1 W:'$D(IOP) *7,"  [NOT Available]" G RESX
+RES2 S X=$P(^%ZISL(3.54,%ZISD0,0),"^",2)
+ I X<1 S POP=1 W:'$D(IOP) *7,"  [NOT Available]" G RESX
+ S X=$S(X>0:X-1,1:0),$P(^%ZISL(3.54,%ZISD0,0),"^",2)=X
+ ;
+R1 ;Grab a slot
+ S IO(1,IO)="RES",A=$G(^%ZISL(3.54,%ZISD0,1,0),"^3.542^^")
+ F L=1:1:%ZISRL I '$D(^%ZISL(3.54,%ZISD0,1,L,0)) Q
+ I '$T K IO(1,IO) G RES2 ;No free slots
+ S ^%ZISL(3.54,%ZISD0,1,L,0)=L_"^"_%ZISV_"^"_$J_"^"_$G(ZTSK)_"^"_$H,^%ZISL(3.54,"AJ",$J,%ZISD0,L)="",^%ZISL(3.54,%ZISD0,1,"B",L,L)=""
+ S $P(A,"^",3,4)=L_U_($P(A,U,4)+1),^%ZISL(3.54,%ZISD0,1,0)=A
+RESX L -^%ZISL(3.54,%ZISD0,0) Q
+ ;
+RADD(X) ;Add Resource
+ N %1,%2
+ S %1=$G(^%ZISL(3.54,0),"RESOURCE^3.54^^"),%2=$P(%1,U,3)
+ F %2=%2:1 Q:'$D(^%ZISL(3.54,%2,0))
+ S $P(^%ZISL(3.54,0),U,3,4)=%2_U_($P(%1,U,4)+1),^%ZISL(3.54,%2,0)=X_"^"_$G(%ZISRL,1),^%ZISL(3.54,"B",X,%2)=""
+ Q %2
+ ;
+RESOK ;DEVOK check for RES devices, for all OS's.
+ N %ZISD0,%ZISD1
+ S Y=0,%ZISD0=$O(^%ZISL(3.54,"B",X,0))
+ I '%ZISD0 S Y=-1,%ZISD0=$O(^%ZIS(1,"C",X,0)) Q:'%ZISD0  Q:'$D(^%ZIS(1,+%ZISD0,0))  Q:$P(^(0),"^")'=X  Q:'$D(^("TYPE"))  Q:^("TYPE")'="RES"  S Y=0 Q
+ S X1=$G(^%ZISL(3.54,+%ZISD0,0))
+ I $P(X1,"^",2)&(X=$P(X1,"^")) S Y=0 Q
+ S Y=999 F %ZISD1=0:0 S %ZISD1=$O(^%ZISL(3.54,%ZISD0,1,%ZISD1)) Q:%ZISD1'>0  I $D(^(%ZISD1,0)) S Y=$P(^(0),"^",3) Q
+ Q
+ ;
+Q G Q^%ZIS3
+HG ;
+ Q
+SPL N %E,%Z D MARGN^%ZIS3 W:'$D(IOP) ! D SPOOL^%ZIS4:%IS'["T" ;Spool type
+ G Q
+MT D MARGN^%ZIS3,ASKPAR,AMTREW:'POP&'$D(IOP)&%ZISB W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T")) ;Magtape type
+ G Q
+SDP D MARGN^%ZIS3,ASKPAR W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T")) ;Sequential disk processor type
+ G Q
+HFS D MARGN^%ZIS3,HFS^%ZIS4 W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T")) ;Host File Server type
+ G Q
+RES G Q:%IS["T" N X,X1 I %IS'["R"!'$D(IOP) S POP=1 W:'$D(IOP) *7,"  [NOT AVAILABLE]" Q  ;Resources
+ G Q:$D(IO(1,IO)) I %IS["T" S X=IO,X1="RES" D DEVOK^%ZIS3 S:Y POP=1 G Q:POP
+ D:%ZISB RES1 G Q
+CHAN ;Network Channel type devices -- DecNet or TCP/IP devices.
+ I IO="SYS$NET",$I="SYS$INPUT:;" S IO(0)=IO U IO ;DECNET Server Device
+ D MARGN^%ZIS3:'POP,ASKPAR:'POP W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T"))
+ G Q
+IMPC ;Imaging Work Station
+BAR ;Bar Code
+OTH D MARGN^%ZIS3:'POP,ASKPAR:'POP W:'$D(IOP) ! D O^%ZIS4:'POP&(%ZISB&(%IS'["T")) ;Other Device type
+ G Q
+ ;
+ASKPAR G SETPAR^%ZIS3:$D(IOP),SETPAR^%ZIS3:'$P(^%ZIS(1,%E,0),"^",4) W "  ADDRESS/PARAMETERS: " W:%ZISOPAR]"" %ZISOPAR_"// " D SBR^%ZIS1 D MSG1:%X="?" G ASKPAR:%X="?" S:%X]"" %ZISOPAR=%X I $D(DTOUT)!$D(DUOUT) S POP=1
+ I POP,%ZISB&(%ZTYPE["TRM") C IO K IO(1,IO) Q
+ Q:POP  G SETPAR^%ZIS3
+AMTREW I %ZISB,%ZTYPE="MT",'$D(IOP) W "  REWIND" S %=2,U="^",%ZISDTIM=60 D YN^%ZIS1 K %ZISDTIM G AMTREW:%=0 I %=-1 S POP=1 Q
+ S:%=1 %ZISMTR=1 Q
+MSG1 W !?5,"Enter the desired parameters needed to open the selected device.",!?25 Q
+ ;
Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZISC.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZISC.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZISC.m	(revision 623)
@@ -1,130 +1,131 @@
-%ZISC	;SFISC/GFT,AC,MUS - CLOSE LOGIC FOR DEVICES  ;1/24/08  16:09
-	;;8.0;KERNEL;**24,36,49,69,199,216,275,409,440**;JUL 10, 1995;Build 13
-	;Per VHA Directive 2004-038, this routine should not be modified
-C0	;
-	N %,%E,%H,%ZISI,%ZISOS,%ZISX,%ZISV
-	;Clear IO var we will use for reporting
-	K IO("ERROR"),IO("LASTERR"),IO("CLOSE")
-	;Protect ourself from calls with incomplete setup.
-	S:$D(IO)[0 IO=$I S:'$D(IO(0)) IO(0)=$P
-	S U="^",%ZISOS=$G(^%ZOSF("OS")),%ZISV=$G(^("VOL"))
-	;S %=$S(+$G(IOS):IOS,$L($G(ION)):ION,1:IO)
-	S %=$S($L($G(ION)):ION,1:IO) ;p409
-	I (%="")!(IO="") G SETIO:IO(0)]"",END
-	I $G(IOT)="RES" D RES G SETIO ;Handle a resource device
-	;
-	;Define subtype info if not already defined.
-	D SUBTYPE
-	;
-	;perform close execute
-	I $G(IOST(0))>0 D
-	. I $G(^%ZIS(2,+IOST(0),3))]"",$D(IO(1,IO)) D
-	. . U IO S:$X $X=1 D X3^ZISX:'$D(IO("T"))
-	;
-	;Incase the Close execute changed IO, Open IO("HOME") or NULL.
-	I '$L($G(IO)) D  Q
-	. S IOP=$S($L($G(IO("HOME"))):"`"_(+IO("HOME")),1:"NULL") D ^%ZIS
-	. Q
-	;
-	;Perform the following if the device is open.
-	I $D(IO(1,IO)) D
-	. I $G(IO("P"))["B" D  ;Return to normal intensity
-	. . S %=$P($G(^%ZIS(2,+IOST(0),7)),"^",3) I %]"" W @%
-	. I $G(IO("P"))["P" D  ;Return to default pitch
-	. . S %=$G(^%ZIS(2,+IOST(0),12.11)) I %]"" W @%
-	. ;
-	. W:$$FF @IOF ;Issue form feed at close
-	. I $$CLOSPP D X11^ZISX:'$D(IO("T")) K IO("S") ;Close printer port
-	. Q
-	;
-	;Don't use IOCPU as we now use IO(1,IO)
-	I (IO'=IO(0)!$D(IO("C"))),$D(IO(1,IO)) D
-	. U:$S($D(ZTQUEUED):0,'$L($G(IO(0))):0,$D(IO(1,IO(0)))#2:1,1:0) IO(0)
-	. C IO K IO(1,IO) S IO("CLOSE")=IO ;close device
-	;Unlock global used to control access.
-	S %=$G(^XUTL("XQ",$J,"lock",+$G(IOS))) I $L(%) L -@% K ^XUTL("XQ",$J,"lock",IOS)
-	;
-	I $D(IO("SPOOL")) D CLOSE^%ZIS4 ;Special close for spool device
-	;
-SETIO	;
-	;See if old device has PCX code
-	I $G(IOS),$G(^%ZIS(1,+IOS,"PCX"))]"" S %ZISPCX=^("PCX")
-	;Setup the IO(0) device, should be the home device
-	S IO=IO(0),(IOPAR,IOUPAR)="" K IO("T") D CIOS(IO(0))
-	I 'IOS S IOT="TRM" G END
-	S ION=$P(^%ZIS(1,IOS,0),"^",1),IOT=$G(^("TYPE")),IOST(0)=$S(IOT["TRM"&($D(^XUTL("XQ",$J,"IOST(0)"))):^("IOST(0)"),1:$G(^%ZIS(1,IOS,"SUBTYPE")))
-	I IOT["TRM",$D(^XUTL("XQ",$J,"IO")) D HOME^%ZIS G END
-	S %="Y"
-	I IOST(0),$D(^%ZIS(2,IOST(0),1)) S %=^(1),IOM=+%,IOF=$P(%,"^",2),IOSL=$P(%,"^",3),IOBS=$P(%,"^",4)
-	I $D(^%ZIS(1,IOS,91)) S %=^%ZIS(1,IOS,91) S:+% IOM=+% S:$P(%,"^",3) IOSL=$P(%,"^",3)
-	;Don't know the subtype so set some defaults
-	I %="Y" S IOM=80,IOSL=24,IOF="#",IOST="C-OTHER",IOBS="$C(8)"
-S1	S:IOST(0) IOST=$P($G(^%ZIS(2,+IOST(0),0)),"^"),IOXY=$G(^("XY"))
-	I '$D(ZTQUEUED),'$D(IO("C")),IOT["TRM" D RM:$D(IO(1,IO))
-	;With home device set, Do Post-close execute code of Device closed.
-END	I '$D(IO("T")),$G(%ZISPCX)]"" S %Y=%ZISPCX D %Y^ZISX
-	;See that any extra IO variables are cleaned up
-	K IO("P"),IO("DOC"),IO("HFSIO"),IO("SPOOL"),IOC,IONOFF
-	;IOCPU should not be changed.
-	Q
-	;
-SUBTYPE	;Find a subtype
-	N %S
-	S IOST=$G(IOST),IOST(0)=+$G(IOST(0))
-	I $L(IOST)&$L(IOST(0)) Q  ;Have a subtype
-	S %S=$G(^%ZIS(2,+IOST(0),0)) I $L(%S) S IOST=$P(%S,U) Q
-	I $L(IOST) S %S=$O(^%ZIS(2,"B",$G(IOST,"X"),0)) I %S>0 S IOST(0)=+%S Q
-	S IOST="",IOST(0)=0 D CIOS($I) Q:IOS'>0
-	S IOST(0)=$G(^%ZIS(1,+IOS,"SUBTYPE")),IOST=$P($G(^%ZIS(2,+IOST(0),0)),"^")
-	Q
-	;
-CIOS(%I)	;Find a value for IOS (IEN into device file)
-	N %ZISVT
-	I $D(^XUTL("XQ",$J,"IOS")) S IOS=+^("IOS") Q
-	I $D(%ZISV) S %ZISVT=%I D VTLKUP^%ZIS S IOS=+%E
-	E  S IOS=+$O(^%ZIS(1,"C",%I,0))
-	Q:$G(IOS)>0
-	S %ZISVT=%I D VIRTUAL^%ZIS
-	I $D(%ZISVT) S %H=%E I %ZISVT]"",%H>0,$D(^%ZIS(1,%H,0)),$D(^("TYPE")),^("TYPE")="VTRM" S IOS=%H
-	Q
-	;
-RM	N X S X=+IOM X ^%ZOSF("RM")
-	Q
-	;
-RES	;Close resource device.
-	Q:'$D(IO(1,IO))&'$D(^%ZISL(3.54,"AJ",$J))
-	N %ZISJOB,%X,%Y,%ZISD0,%ZISD1,%ZISRES,%ZISRL,%ZISY0,%ZTRTN,ZTSAVE,ZTIO
-	S %ZISJOB=$J
-	;
-RES1	G RQ:'$D(IOS),RQ:'$D(^%ZIS(1,+IOS,1)) S %ZISRL=+$P(^(1),"^",10),%ZISRL=$S(%ZISRL:%ZISRL,1:1)
-	S %X=$O(^%ZISL(3.54,"B",IO,0)) G RQ:'%X
-	G RQ:'$D(^%ZISL(3.54,+%X,0)) S %ZISD0=+%X,%ZISY0=^(0)
-	S %X=$O(^%ZISL(3.54,"AJ",%ZISJOB,%ZISD0,0)) S %ZISD1=%X G RQ:'%X
-	S %Y=$G(^%ZISL(3.54,%ZISD0,1,+%ZISD1,0)) G RQ:$P(%Y,"^",3)'=%ZISJOB
-	D KILLRES(+%ZISD0,+%ZISD1)
-RQ	K IO(1,IO)
-	Q
-	;
-KILLRES(D0,D1)	;Kill one resource use
-	Q:(D0'>0)!(D1'>0)
-	N %X,%Y,%J,%ZISRL
-	L +^%ZISL(3.54,D0,0)
-	S %Y=$G(^%ZISL(3.54,D0,0)) G KRX:%Y=""
-	S %X=$G(^%ZISL(3.54,D0,1,D1,0)),%J=$P(%X,"^",3) S:%J="" %J=" "
-	K ^%ZISL(3.54,D0,1,D1,0),^%ZISL(3.54,D0,1,"B",D1,D1),^%ZISL(3.54,"AJ",%J,D0,D1)
-	S %X=$P(%Y,"^",2)+1,$P(^%ZISL(3.54,D0,0),"^",2)=%X
-	;I '$D(^%ZISL(3.54,%ZISD0,1,0)) S ^(0)="^3.542A^^" G RQ
-	S %Y=$G(^%ZISL(3.54,D0,1,0)),%X=$P(%Y,"^",4),$P(^%ZISL(3.54,D0,1,0),"^",3,4)="^"_$S(%X>0:(%X-1),1:0)
-KRX	L -^%ZISL(3.54,D0,0)
-	Q
-	;
-DQCRES	;Tasked entry point to close resource device.
-	S IO=%ZISRES G RES1
-	;
-FF()	;Issue form feed
-	I $E(IOST,1,2)'["C-",$D(IO(1,IO)),$G(IOT)="TRM"!($G(IOT)="SPL"),'$D(IO("T"))&$Y&'$D(IONOFF)&'$D(IO(1,IO,"NOFF")) Q 1
-	Q 0
-	;
-CLOSPP()	;Close printer port
-	I $D(IO("S")),$D(^%ZIS(2,+IO("S"),11))&$D(IO(1,IO)) Q 1
-	Q 0
+%ZISC ;SFISC/GFT,AC,MUS - CLOSE LOGIC FOR DEVICES  ;01/14/2002  09:06
+ ;;8.0;KERNEL;**24,36,49,69,199,216,275,409**;JUL 10, 1995;Build 3
+C0 ;
+ N %,%E,%H,%ZISI,%ZISOS,%ZISX,%ZISV
+ ;Clear IO var we will use for reporting
+ K IO("ERROR"),IO("LASTERR"),IO("CLOSE")
+ ;Protect ourself from calls with incomplete setup.
+ S:$D(IO)[0 IO=$I S:'$D(IO(0)) IO(0)=$P
+ S U="^",%ZISOS=$G(^%ZOSF("OS")),%ZISV=$G(^("VOL"))
+ ;S %=$S(+$G(IOS):IOS,$L($G(ION)):ION,1:IO)
+ S %=$S($L($G(ION)):ION,1:IO) ;p409
+ I (%="")!(IO="") G SETIO:IO(0)]"",END
+ I $G(IOT)="RES" D RES G SETIO ;Handle a resource device
+ ;
+ ;Define subtype info if not already defined.
+ D SUBTYPE
+ ;
+ ;perform close execute
+ I $G(IOST(0))>0 D
+ . I $G(^%ZIS(2,+IOST(0),3))]"",$D(IO(1,IO)) D
+ . . U IO S:$X $X=1 D X3^ZISX:'$D(IO("T"))
+ ;
+ ;Incase the Close execute changed IO, Open IO("HOME") or NULL.
+ I '$L($G(IO)) D  Q
+ . S IOP=$S($L($G(IO("HOME"))):"`"_(+IO("HOME")),1:"NULL") D ^%ZIS
+ . Q
+ ;
+ ;Perform the following if the device is open.
+ I $D(IO(1,IO)) D
+ . I $G(IO("P"))["B" D  ;Return to normal intensity
+ . . S %=$P($G(^%ZIS(2,+IOST(0),7)),"^",3) I %]"" W @%
+ . I $G(IO("P"))["P" D  ;Return to default pitch
+ . . S %=$G(^%ZIS(2,+IOST(0),12.11)) I %]"" W @%
+ . ;
+ . W:$$FF @IOF ;Issue form feed at close
+ . I $$CLOSPP D X11^ZISX:'$D(IO("T")) K IO("S") ;Close printer port
+ . Q
+ ;
+ ;Don't use IOCPU as we now use IO(1,IO)
+ I (IO'=IO(0)!$D(IO("C"))),$D(IO(1,IO)) D
+ . U:$S($D(ZTQUEUED):0,'$L($G(IO(0))):0,$D(IO(1,IO(0)))#2:1,1:0) IO(0)
+ . C IO K IO(1,IO) S IO("CLOSE")=IO ;close device
+ ;
+ ;
+ I $D(IOT),IOT="CHAN",$D(IOS) D
+ .S %=$G(^%ZIS(1,+IOS,"GBL"))
+ .I %]"" L @("-^"_%) ;unlock global used to control access to network channels.
+ I $D(IO("SPOOL")) D CLOSE^%ZIS4 ;Special close for spool device
+ ;
+SETIO ;
+ ;See if old device has PCX code
+ I $G(IOS),$G(^%ZIS(1,+IOS,"PCX"))]"" S %ZISPCX=^("PCX")
+ ;Setup the IO(0) device, should be the home device
+ S IO=IO(0),(IOPAR,IOUPAR)="" K IO("T") D CIOS(IO(0))
+ I 'IOS S IOT="TRM" G END
+ S ION=$P(^%ZIS(1,IOS,0),"^",1),IOT=$G(^("TYPE")),IOST(0)=$S(IOT["TRM"&($D(^XUTL("XQ",$J,"IOST(0)"))):^("IOST(0)"),1:$G(^%ZIS(1,IOS,"SUBTYPE")))
+ I IOT["TRM",$D(^XUTL("XQ",$J,"IO")) D HOME^%ZIS G END
+ S %="Y"
+ I IOST(0),$D(^%ZIS(2,IOST(0),1)) S %=^(1),IOM=+%,IOF=$P(%,"^",2),IOSL=$P(%,"^",3),IOBS=$P(%,"^",4)
+ I $D(^%ZIS(1,IOS,91)) S %=^%ZIS(1,IOS,91) S:+% IOM=+% S:$P(%,"^",3) IOSL=$P(%,"^",3)
+ ;Don't know the subtype so set some defaults
+ I %="Y" S IOM=80,IOSL=24,IOF="#",IOST="C-OTHER",IOBS="$C(8)"
+S1 S:IOST(0) IOST=$P($G(^%ZIS(2,+IOST(0),0)),"^"),IOXY=$G(^("XY"))
+ I '$D(ZTQUEUED),'$D(IO("C")),IOT["TRM" D RM:$D(IO(1,IO))
+ ;With home device set, Do Post-close execute code of Device closed.
+END I '$D(IO("T")),$G(%ZISPCX)]"" S %Y=%ZISPCX D %Y^ZISX
+ ;See that any extra IO variables are cleaned up
+ K IO("P"),IO("DOC"),IO("HFSIO"),IO("SPOOL"),IOC,IONOFF
+ ;IOCPU should not be changed.
+ Q
+ ;
+SUBTYPE ;Find a subtype
+ N %S
+ S IOST=$G(IOST),IOST(0)=+$G(IOST(0))
+ I $L(IOST)&$L(IOST(0)) Q  ;Have a subtype
+ S %S=$G(^%ZIS(2,+IOST(0),0)) I $L(%S) S IOST=$P(%S,U) Q
+ I $L(IOST) S %S=$O(^%ZIS(2,"B",$G(IOST,"X"),0)) I %S>0 S IOST(0)=+%S Q
+ S IOST="",IOST(0)=0 D CIOS($I) Q:IOS'>0
+ S IOST(0)=$G(^%ZIS(1,+IOS,"SUBTYPE")),IOST=$P($G(^%ZIS(2,+IOST(0),0)),"^")
+ Q
+ ;
+CIOS(%I) ;Find a value for IOS (IEN into device file)
+ N %ZISVT
+ I $D(^XUTL("XQ",$J,"IOS")) S IOS=+^("IOS") Q
+ I $D(%ZISV) S %ZISVT=%I D VTLKUP^%ZIS S IOS=+%E
+ E  S IOS=+$O(^%ZIS(1,"C",%I,0))
+ Q:$G(IOS)>0
+ S %ZISVT=%I D VIRTUAL^%ZIS
+ I $D(%ZISVT) S %H=%E I %ZISVT]"",%H>0,$D(^%ZIS(1,%H,0)),$D(^("TYPE")),^("TYPE")="VTRM" S IOS=%H
+ Q
+ ;
+RM N X S X=+IOM X ^%ZOSF("RM")
+ Q
+ ;
+RES ;Close resource device.
+ Q:'$D(IO(1,IO))&'$D(^%ZISL(3.54,"AJ",$J))
+ N %ZISJOB,%X,%Y,%ZISD0,%ZISD1,%ZISRES,%ZISRL,%ZISY0,%ZTRTN,ZTSAVE,ZTIO
+ S %ZISJOB=$J
+ ;
+RES1 G RQ:'$D(IOS),RQ:'$D(^%ZIS(1,+IOS,1)) S %ZISRL=+$P(^(1),"^",10),%ZISRL=$S(%ZISRL:%ZISRL,1:1)
+ S %X=$O(^%ZISL(3.54,"B",IO,0)) G RQ:'%X
+ G RQ:'$D(^%ZISL(3.54,+%X,0)) S %ZISD0=+%X,%ZISY0=^(0)
+ S %X=$O(^%ZISL(3.54,"AJ",%ZISJOB,%ZISD0,0)) S %ZISD1=%X G RQ:'%X
+ S %Y=$G(^%ZISL(3.54,%ZISD0,1,+%ZISD1,0)) G RQ:$P(%Y,"^",3)'=%ZISJOB
+ D KILLRES(+%ZISD0,+%ZISD1)
+RQ K IO(1,IO)
+ Q
+ ;
+KILLRES(D0,D1) ;Kill one resource use
+ Q:(D0'>0)!(D1'>0)
+ N %X,%Y,%J,%ZISRL
+ L +^%ZISL(3.54,D0,0)
+ S %Y=$G(^%ZISL(3.54,D0,0)) G KRX:%Y=""
+ S %X=$G(^%ZISL(3.54,D0,1,D1,0)),%J=$P(%X,"^",3) S:%J="" %J=" "
+ K ^%ZISL(3.54,D0,1,D1,0),^%ZISL(3.54,D0,1,"B",D1,D1),^%ZISL(3.54,"AJ",%J,D0,D1)
+ S %X=$P(%Y,"^",2)+1,$P(^%ZISL(3.54,D0,0),"^",2)=%X
+ ;I '$D(^%ZISL(3.54,%ZISD0,1,0)) S ^(0)="^3.542A^^" G RQ
+ S %Y=$G(^%ZISL(3.54,D0,1,0)),%X=$P(%Y,"^",4),$P(^%ZISL(3.54,D0,1,0),"^",3,4)="^"_$S(%X>0:(%X-1),1:0)
+KRX L -^%ZISL(3.54,D0,0)
+ Q
+ ;
+DQCRES ;Tasked entry point to close resource device.
+ S IO=%ZISRES G RES1
+ ;
+FF() ;Issue form feed
+ I $E(IOST,1,2)'["C-",$D(IO(1,IO)),$G(IOT)="TRM"!($G(IOT)="SPL"),'$D(IO("T"))&$Y&'$D(IONOFF)&'$D(IO(1,IO,"NOFF")) Q 1
+ Q 0
+ ;
+CLOSPP() ;Close printer port
+ I $D(IO("S")),$D(^%ZIS(2,+IO("S"),11))&$D(IO(1,IO)) Q 1
+ Q 0
Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZISEDIT.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZISEDIT.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/ZISEDIT.m	(revision 623)
@@ -1,49 +1,23 @@
-ZISEDIT	;ISF/AC - DEVICE EDIT ;01/17/2008
-	;;8.0;KERNEL;**440**;Jul 10, 1995;Build 13
-	;
-TRM	;TRM or VTRM
-	D EDIT("TRM",,"Select Terminal/Printer Device: ")
-	Q
-	;
-LPD	;LPD fields of a TRM device
-	D EDIT("LPD","TRM","Select LPD (Terminal/Printer) Device: ")
-	Q
-	;
-MT	;Mag Tape
-	D EDIT("MT",,"Select Magtape Device: ")
-	Q
-	;
-SDP	;
-	D EDIT("SDP",,"Select SDP Device: ")
-	Q
-	;
-SPL	;Spool
-	D EDIT("SPL",,"Select Spool Device: ")
-	Q
-	;
-HFS	;Host file
-	D EDIT("HFS",,"Select Host File Device: ")
-	Q
-	;
-CHAN	;Network
-	D EDIT("CHAN",,"Select Network Channel: ")
-	Q
-	;
-RES	;Resource
-	D EDIT("RES",,"Select Resource Device: ")
-	Q
-	;
-EDIT(ZISTYPE,ZISSCR,DICA)	;
-	N Y,DA,DIC,DIE,DR,DDSFILE
-ED2	S DIC("A")=DICA,ZISSCR=$G(ZISSCR,ZISTYPE)
-	S DIC=3.5,DIC(0)="AEMQZL",DIC("S")="I $G(^(""TYPE""))["_""""_ZISSCR_"""" D ^DIC
-	Q:Y'>0
-	S DA=+Y
-	I $P(Y,"^",3) D
-	. N DIE,DR
-	. S DIE=DIC,DR="2///"_ZISTYPE_$S(ZISTYPE["TRM":"",1:";1.95///N")
-	. D ^DIE
-	. Q
-	S DR="[XUDEVICE "_ZISTYPE_"]",DDSFILE=3.5 D ^DDS
-	G ED2
-	Q
+ZISEDIT ;SFISC/AC - DEVICE EDIT ;11/9/92  17:00
+ ;;8.0;KERNEL;;Jul 10, 1995
+ ;
+MT S ZISTYPE="MT",DIC("A")="Select Magtape Device: " D EDIT K ZISTYPE
+ Q
+ ;
+SDP S ZISTYPE="SDP",DIC("A")="Select SDP Device: " D EDIT K ZISTYPE
+ Q
+ ;
+SPL S ZISTYPE="SPL",DIC("A")="Select Spool Device: " D EDIT K ZISTYPE
+ Q
+ ;
+HFS S ZISTYPE="HFS",DIC("A")="Select Host File Device: " D EDIT K ZISTYPE
+ Q
+ ;
+CHAN S ZISTYPE="CHAN",DIC("A")="Select Network Channel: " D EDIT K ZISTYPE
+ Q
+ ;;7.1P0;Kernel;;
+EDIT S DIC=3.5,DIC(0)="AEMQZL",DIC("S")="I $G(^(""TYPE""))="_""""_ZISTYPE_"""" D ^DIC
+ I Y'>0 K DIC Q
+ S DA=+Y I $P(Y,"^",3) S DIE=DIC,DR="2///"_ZISTYPE D ^DIE K DIE,DR
+ S DR="[XUDEVICE "_ZISTYPE_"]",DDSFILE=3.5 D ^DDS
+ K DA,DR,DDSFILE Q
